#ifndef _hiteck_mouse_h_
#define _hiteck_mouse_h_

#include <i86.h>

signed int mouse_init()
{
	union REGS r;
	r.x.eax = 0;
	int386(0x33, &r, &r);
	
	return r.x.eax;
}

void mouse_setrate(short hx, short hy)
{
	union REGS r;
	r.x.eax = 0x4f03;
	int386(0x10, &r, &r);
	short vidmode = r.x.ebx;

	r.x.eax = 0x4f02;
	r.x.ebx = 0x12;
	int386(0x10, &r, &r);

	r.x.eax = 15;
	r.x.ecx = hx;
	r.x.edx = hy;
	int386(0x33, &r, &r);

	r.x.eax = 0x4f02;
	r.x.ebx = vidmode;
	int386(0x10, &r, &r);
}


void mouse_setpos(short x, short y)
{
	union REGS r;
	r.x.eax = 4;
	r.x.ecx = x;
	r.x.edx = y;
	int386(0x33, &r, &r);
}


void mouse_setrange(short x, short x2, short y, short y2)
{
	union REGS r;
	r.x.eax = 7;
	r.x.ecx = x;
	r.x.edx = y;
	int386(0x33, &r, &r);
	r.x.eax = 8;
	r.x.ecx = x2;
	r.x.edx = y2;
	int386(0x33, &r, &r);
}


void mouse_lastclick(short button, short &presscount, short &x, short &y)
{
	union REGS r;
	r.x.eax = 5;
	r.x.ebx = button;
	int386(0x33, &r, &r);
	presscount = r.x.ebx;
	x = r.x.ecx;
	y = r.x.edx;
}


void mouse_lastrelease(short button, short &releasecount, short &x, short &y)
{
	union REGS r;
	r.x.eax = 6;
	r.x.ebx = button;
	int386(0x33, &r, &r);
	releasecount = r.x.ebx;
	x = r.x.ecx;
	y = r.x.edx;
}


void mouse_relpos(signed short &x, signed short &y)
{
	union REGS r;
	r.x.eax = 11;
	int386(0x33, &r, &r);
	x = r.x.ecx;
	y = r.x.edx;
}


void mouse_show()
{
	union REGS r;
	r.x.eax = 1;
	int386(0x33, &r, &r);
}

void mouse_hide()
{
	union REGS r;
	r.x.eax = 2;
	int386(0x33, &r, &r);
}


void mouse_status(short &x, short &y, short &b1, short &b2)
{
	static short mx, my;
	short tx, ty;
	
	union REGS r;
	r.x.eax = 3;
	int386(0x33, &r, &r);
	x = r.x.ecx;
	y = r.x.edx;
	b1 = (r.x.ebx & 1) != 0;
	b2 = (r.x.ebx & 2) != 0;
	
	mouse_relpos (tx, ty);
	mx+=tx/8; my+=ty/8;
	if (mx<0) mx=0; if (my<0) my=0;
	x = mx; y = my;
}

#ifdef gcursor
bitmaptype mouse_cr;
bitmaptype mouse_bk;

void mouse_loadcursor(unsigned char *vbuff, cliptype clip, char *filename, short x, short y)
{
	#ifdef hicolor
		load_bitmap (&mouse_cr, filename, x, y, 1, 0,0,0, 1.0);
		load_bitmap (&mouse_bk, filename, x, y, 0, 0,0,0, 1.0);
	#else
//		load_bitmap (mouse_cr, filename, x, y, 1, 0,0,0, 1.0);
//		load_bitmap (mouse_bk, filename, x, y, 0, 0,0,0, 1.0);
	#endif
	short mx, my, b1, b2;
	mouse_status(mx,my,b1,b2);
	getimg (vbuff, mx, my, mx+x, my+y, mouse_bk.data, clip);
}

void mouse_gupdate(unsigned char *vbuff, cliptype clip)
{
	static oldmx, oldmy;
	short mx, my, b1, b2;
	mouse_status(mx,my,b1,b2);
	unsigned char *dummy;
	
	if ((oldmx!=mx) || (oldmy!=my))
	{
		putimg (vbuff, oldmx, oldmy, &mouse_bk, dummy, clip);
		getimg (vbuff, mx, my, mx+mouse_bk.xsize, my+mouse_bk.ysize, mouse_bk.data,clip);
		putimg (vbuff, mx, my, &mouse_cr, dummy, clip);
	}
	oldmx=mx;oldmy=my;
}
#endif

#endif