#ifndef _hiteck_palette_h_
#define _hiteck_palette_h_

#include <conio.h>
#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>

void setpal(char *pal)
{
    for (int i=0; i<256; i++)
    {
        outp(0x3c8,i);
        outp(0x3c9,pal[i*3]);
        outp(0x3c9,pal[i*3+1]);
        outp(0x3c9,pal[i*3+2]);
    }
}

void getpal(unsigned char *pal)
{
    int i;
    outp(0x3c7,0x00);
    for (i = 0; i < 3*256; i++)
    {    
        pal[i]=(unsigned char)inp(0x3c9);
    }
}




void generatetranstable(unsigned char *ttable, char *pal)
{
	int x,y, i;
	int r,g,b, avg, value, match;
	
	for (x=0;x<256;x++) {
		for (y=0;y<256;y++)
		{
			r = pal[x*3+0] + pal[y*3+0]/2;
			g = pal[x*3+1] + pal[y*3+1]/2;
			b = pal[x*3+2] + pal[y*3+2]/2;

  		avg=256;
 	 	for (i=0;i<256;i++)
			{
				value = (abs(pal[i*3]-r)) + abs(pal[i*3+1]-g) + abs(pal[i*3+2]-b);
				if (value<avg)
				{
					avg=value;
					match=i;
				}
			}
			ttable[x*256+y] = match;
		}
  }
}		





void savettable(char *filename, unsigned char *ttable)
{
	fstream tfile;
	tfile.open(filename, ios::out | ios::binary);
	if (tfile.good()) 
		tfile.write((unsigned char *) ttable, 256*256);
	tfile.close();
}

void loadttable(char *filename, unsigned char *ttable)
{
	if (ttable==NULL) return;
	fstream tfile;
	tfile.open(filename, ios::in | ios::nocreate | ios::binary);
	if (tfile.good()) 
		tfile.read((unsigned char *) ttable, 256*256);
	tfile.close();
}






void generatecolortable(unsigned char *ctable, char *pal)
{
#ifdef pal666
	int r,g,b;
	for (r=0;r<64;r++) {
		for (g=0;g<64;g++) {
			for (b=0;b<64;b++)
			{
				ctable[r*4096+g*64+b] = (b*4)/54 + ((g*4)/54)*6 + ((r*4)/54)*36;
			}
	  }
	}
#else
	int r,g,b, match;
	int avg,i, value;
	
	for (r=0;r<64;r++) {
		for (g=0;g<64;g++) {
			for (b=0;b<64;b++)
			{
				avg=256;
				for (i=0;i<256;i++)
				{
					value = (abs(pal[i*3]-r)) + abs(pal[i*3+1]-g) + abs(pal[i*3+2]-b);
					if (value<avg)
					{
						avg=value;
						match=i;
					}
				}
				ctable[r*4096+g*64+b] = match;
			}
	  }
  	cout << match << " R:" << r << " G:" << g << " B:" << b << endl;
	}
#endif
}

void savectable(char *filename, unsigned char *ctable)
{
	fstream tfile;
	tfile.open(filename, ios::out | ios::binary);
	if (tfile.good()) 
		tfile.write((char *) ctable, 64*64*64);
	tfile.close();
}

void loadctable(char *filename, unsigned char *ctable)
{
	if (ctable==NULL) return;
	fstream tfile;
	tfile.open(filename, ios::in | ios::nocreate | ios::binary);
	if (tfile.good()) 
		tfile.read((char *) ctable, 64*64*64);
	tfile.close();
}

void loadrawpal(char *filename, char *pal)
{
	fstream palfile;
	palfile.open(filename, ios::in | ios::nocreate | ios::binary);
	if (palfile.good()) 
		palfile.read((char *) pal, 768);
	palfile.close();
}

#endif